<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/object-0.29.0/src/read/mod.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>mod.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../storage.js"></script><script defer src="../../../source-script.js"></script><script defer src="../../../source-files.js"></script><script defer src="../../../main.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../object/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../object/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../object/index.html"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
<span id="380">380</span>
<span id="381">381</span>
<span id="382">382</span>
<span id="383">383</span>
<span id="384">384</span>
<span id="385">385</span>
<span id="386">386</span>
<span id="387">387</span>
<span id="388">388</span>
<span id="389">389</span>
<span id="390">390</span>
<span id="391">391</span>
<span id="392">392</span>
<span id="393">393</span>
<span id="394">394</span>
<span id="395">395</span>
<span id="396">396</span>
<span id="397">397</span>
<span id="398">398</span>
<span id="399">399</span>
<span id="400">400</span>
<span id="401">401</span>
<span id="402">402</span>
<span id="403">403</span>
<span id="404">404</span>
<span id="405">405</span>
<span id="406">406</span>
<span id="407">407</span>
<span id="408">408</span>
<span id="409">409</span>
<span id="410">410</span>
<span id="411">411</span>
<span id="412">412</span>
<span id="413">413</span>
<span id="414">414</span>
<span id="415">415</span>
<span id="416">416</span>
<span id="417">417</span>
<span id="418">418</span>
<span id="419">419</span>
<span id="420">420</span>
<span id="421">421</span>
<span id="422">422</span>
<span id="423">423</span>
<span id="424">424</span>
<span id="425">425</span>
<span id="426">426</span>
<span id="427">427</span>
<span id="428">428</span>
<span id="429">429</span>
<span id="430">430</span>
<span id="431">431</span>
<span id="432">432</span>
<span id="433">433</span>
<span id="434">434</span>
<span id="435">435</span>
<span id="436">436</span>
<span id="437">437</span>
<span id="438">438</span>
<span id="439">439</span>
<span id="440">440</span>
<span id="441">441</span>
<span id="442">442</span>
<span id="443">443</span>
<span id="444">444</span>
<span id="445">445</span>
<span id="446">446</span>
<span id="447">447</span>
<span id="448">448</span>
<span id="449">449</span>
<span id="450">450</span>
<span id="451">451</span>
<span id="452">452</span>
<span id="453">453</span>
<span id="454">454</span>
<span id="455">455</span>
<span id="456">456</span>
<span id="457">457</span>
<span id="458">458</span>
<span id="459">459</span>
<span id="460">460</span>
<span id="461">461</span>
<span id="462">462</span>
<span id="463">463</span>
<span id="464">464</span>
<span id="465">465</span>
<span id="466">466</span>
<span id="467">467</span>
<span id="468">468</span>
<span id="469">469</span>
<span id="470">470</span>
<span id="471">471</span>
<span id="472">472</span>
<span id="473">473</span>
<span id="474">474</span>
<span id="475">475</span>
<span id="476">476</span>
<span id="477">477</span>
<span id="478">478</span>
<span id="479">479</span>
<span id="480">480</span>
<span id="481">481</span>
<span id="482">482</span>
<span id="483">483</span>
<span id="484">484</span>
<span id="485">485</span>
<span id="486">486</span>
<span id="487">487</span>
<span id="488">488</span>
<span id="489">489</span>
<span id="490">490</span>
<span id="491">491</span>
<span id="492">492</span>
<span id="493">493</span>
<span id="494">494</span>
<span id="495">495</span>
<span id="496">496</span>
<span id="497">497</span>
<span id="498">498</span>
<span id="499">499</span>
<span id="500">500</span>
<span id="501">501</span>
<span id="502">502</span>
<span id="503">503</span>
<span id="504">504</span>
<span id="505">505</span>
<span id="506">506</span>
<span id="507">507</span>
<span id="508">508</span>
<span id="509">509</span>
<span id="510">510</span>
<span id="511">511</span>
<span id="512">512</span>
<span id="513">513</span>
<span id="514">514</span>
<span id="515">515</span>
<span id="516">516</span>
<span id="517">517</span>
<span id="518">518</span>
<span id="519">519</span>
<span id="520">520</span>
<span id="521">521</span>
<span id="522">522</span>
<span id="523">523</span>
<span id="524">524</span>
<span id="525">525</span>
<span id="526">526</span>
<span id="527">527</span>
<span id="528">528</span>
<span id="529">529</span>
<span id="530">530</span>
<span id="531">531</span>
<span id="532">532</span>
<span id="533">533</span>
<span id="534">534</span>
<span id="535">535</span>
<span id="536">536</span>
<span id="537">537</span>
<span id="538">538</span>
<span id="539">539</span>
<span id="540">540</span>
<span id="541">541</span>
<span id="542">542</span>
<span id="543">543</span>
<span id="544">544</span>
<span id="545">545</span>
<span id="546">546</span>
<span id="547">547</span>
<span id="548">548</span>
<span id="549">549</span>
<span id="550">550</span>
<span id="551">551</span>
<span id="552">552</span>
<span id="553">553</span>
<span id="554">554</span>
<span id="555">555</span>
<span id="556">556</span>
<span id="557">557</span>
<span id="558">558</span>
<span id="559">559</span>
<span id="560">560</span>
<span id="561">561</span>
<span id="562">562</span>
<span id="563">563</span>
<span id="564">564</span>
<span id="565">565</span>
<span id="566">566</span>
<span id="567">567</span>
<span id="568">568</span>
<span id="569">569</span>
<span id="570">570</span>
<span id="571">571</span>
<span id="572">572</span>
<span id="573">573</span>
<span id="574">574</span>
<span id="575">575</span>
<span id="576">576</span>
<span id="577">577</span>
<span id="578">578</span>
<span id="579">579</span>
<span id="580">580</span>
<span id="581">581</span>
<span id="582">582</span>
<span id="583">583</span>
<span id="584">584</span>
<span id="585">585</span>
<span id="586">586</span>
<span id="587">587</span>
<span id="588">588</span>
<span id="589">589</span>
<span id="590">590</span>
<span id="591">591</span>
<span id="592">592</span>
<span id="593">593</span>
<span id="594">594</span>
<span id="595">595</span>
<span id="596">596</span>
<span id="597">597</span>
<span id="598">598</span>
<span id="599">599</span>
<span id="600">600</span>
<span id="601">601</span>
<span id="602">602</span>
<span id="603">603</span>
<span id="604">604</span>
<span id="605">605</span>
<span id="606">606</span>
<span id="607">607</span>
<span id="608">608</span>
<span id="609">609</span>
<span id="610">610</span>
<span id="611">611</span>
<span id="612">612</span>
<span id="613">613</span>
<span id="614">614</span>
<span id="615">615</span>
<span id="616">616</span>
<span id="617">617</span>
<span id="618">618</span>
<span id="619">619</span>
<span id="620">620</span>
<span id="621">621</span>
<span id="622">622</span>
<span id="623">623</span>
<span id="624">624</span>
<span id="625">625</span>
<span id="626">626</span>
<span id="627">627</span>
<span id="628">628</span>
<span id="629">629</span>
<span id="630">630</span>
<span id="631">631</span>
<span id="632">632</span>
<span id="633">633</span>
<span id="634">634</span>
<span id="635">635</span>
<span id="636">636</span>
<span id="637">637</span>
<span id="638">638</span>
<span id="639">639</span>
<span id="640">640</span>
<span id="641">641</span>
<span id="642">642</span>
<span id="643">643</span>
<span id="644">644</span>
<span id="645">645</span>
<span id="646">646</span>
<span id="647">647</span>
<span id="648">648</span>
<span id="649">649</span>
<span id="650">650</span>
<span id="651">651</span>
<span id="652">652</span>
<span id="653">653</span>
<span id="654">654</span>
<span id="655">655</span>
<span id="656">656</span>
<span id="657">657</span>
<span id="658">658</span>
<span id="659">659</span>
<span id="660">660</span>
<span id="661">661</span>
<span id="662">662</span>
<span id="663">663</span>
<span id="664">664</span>
<span id="665">665</span>
<span id="666">666</span>
<span id="667">667</span>
<span id="668">668</span>
<span id="669">669</span>
<span id="670">670</span>
<span id="671">671</span>
<span id="672">672</span>
<span id="673">673</span>
<span id="674">674</span>
<span id="675">675</span>
<span id="676">676</span>
<span id="677">677</span>
<span id="678">678</span>
<span id="679">679</span>
<span id="680">680</span>
<span id="681">681</span>
<span id="682">682</span>
<span id="683">683</span>
<span id="684">684</span>
<span id="685">685</span>
<span id="686">686</span>
<span id="687">687</span>
<span id="688">688</span>
<span id="689">689</span>
<span id="690">690</span>
<span id="691">691</span>
<span id="692">692</span>
<span id="693">693</span>
<span id="694">694</span>
<span id="695">695</span>
<span id="696">696</span>
<span id="697">697</span>
<span id="698">698</span>
<span id="699">699</span>
<span id="700">700</span>
<span id="701">701</span>
<span id="702">702</span>
<span id="703">703</span>
<span id="704">704</span>
<span id="705">705</span>
<span id="706">706</span>
<span id="707">707</span>
<span id="708">708</span>
<span id="709">709</span>
<span id="710">710</span>
</pre><pre class="rust"><code><span class="doccomment">//! Interface for reading object files.</span>

<span class="kw">use</span> <span class="ident">alloc::borrow::Cow</span>;
<span class="kw">use</span> <span class="ident">alloc::vec::Vec</span>;
<span class="kw">use</span> <span class="ident">core</span>::{<span class="ident">fmt</span>, <span class="ident">result</span>};

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::common</span>::<span class="kw-2">*</span>;

<span class="kw">mod</span> <span class="ident">read_ref</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">read_ref</span>::<span class="kw-2">*</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">mod</span> <span class="ident">read_cache</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">read_cache</span>::<span class="kw-2">*</span>;

<span class="kw">mod</span> <span class="ident">util</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">util</span>::<span class="kw-2">*</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(
    <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;coff&quot;</span>,
    <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;elf&quot;</span>,
    <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;macho&quot;</span>,
    <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;pe&quot;</span>,
    <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;wasm&quot;</span>
))]</span>
<span class="kw">mod</span> <span class="ident">any</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(
    <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;coff&quot;</span>,
    <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;elf&quot;</span>,
    <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;macho&quot;</span>,
    <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;pe&quot;</span>,
    <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;wasm&quot;</span>
))]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">any</span>::<span class="kw-2">*</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;archive&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">archive</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;coff&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">coff</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;elf&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">elf</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;macho&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">macho</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;pe&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">pe</span>;

<span class="kw">mod</span> <span class="ident">traits</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">traits</span>::<span class="kw-2">*</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;wasm&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">wasm</span>;

<span class="kw">mod</span> <span class="ident">private</span> {
    <span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">Sealed</span> {}
}

<span class="doccomment">/// The error type used within the read module.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Error</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> <span class="ident">str</span>);

<span class="kw">impl</span> <span class="ident">fmt::Display</span> <span class="kw">for</span> <span class="ident">Error</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;mut</span> <span class="ident">fmt::Formatter</span>) -&gt; <span class="ident">fmt::Result</span> {
        <span class="ident">f</span>.<span class="ident">write_str</span>(<span class="self">self</span>.<span class="number">0</span>)
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">impl</span> <span class="ident">std::error::Error</span> <span class="kw">for</span> <span class="ident">Error</span> {}

<span class="doccomment">/// The result type used within the read module.</span>
<span class="kw">pub</span> <span class="kw">type</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">result::Result</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">Error</span><span class="op">&gt;</span>;

<span class="kw">trait</span> <span class="ident">ReadError</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">read_error</span>(<span class="self">self</span>, <span class="ident">error</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> <span class="ident">str</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>;
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="ident">ReadError</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">result::Result</span><span class="op">&lt;</span><span class="ident">T</span>, ()<span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">read_error</span>(<span class="self">self</span>, <span class="ident">error</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> <span class="ident">str</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">map_err</span>(<span class="op">|</span>()<span class="op">|</span> <span class="ident">Error</span>(<span class="ident">error</span>))
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="ident">ReadError</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">result::Result</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">Error</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">read_error</span>(<span class="self">self</span>, <span class="ident">error</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> <span class="ident">str</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">map_err</span>(<span class="op">|</span><span class="kw">_</span><span class="op">|</span> <span class="ident">Error</span>(<span class="ident">error</span>))
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="ident">ReadError</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">read_error</span>(<span class="self">self</span>, <span class="ident">error</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> <span class="ident">str</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">ok_or</span>(<span class="ident">Error</span>(<span class="ident">error</span>))
    }
}

<span class="doccomment">/// The native executable file for the target platform.</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(
    <span class="ident">unix</span>,
    <span class="ident">not</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;macos&quot;</span>),
    <span class="ident">target_pointer_width</span> <span class="op">=</span> <span class="string">&quot;32&quot;</span>,
    <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;elf&quot;</span>
))]</span>
<span class="kw">pub</span> <span class="kw">type</span> <span class="ident">NativeFile</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">R</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>]<span class="op">&gt;</span> <span class="op">=</span> <span class="ident">elf::ElfFile32</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident"><span class="kw">crate</span>::Endianness</span>, <span class="ident">R</span><span class="op">&gt;</span>;

<span class="doccomment">/// The native executable file for the target platform.</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(
    <span class="ident">unix</span>,
    <span class="ident">not</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;macos&quot;</span>),
    <span class="ident">target_pointer_width</span> <span class="op">=</span> <span class="string">&quot;64&quot;</span>,
    <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;elf&quot;</span>
))]</span>
<span class="kw">pub</span> <span class="kw">type</span> <span class="ident">NativeFile</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">R</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>]<span class="op">&gt;</span> <span class="op">=</span> <span class="ident">elf::ElfFile64</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident"><span class="kw">crate</span>::Endianness</span>, <span class="ident">R</span><span class="op">&gt;</span>;

<span class="doccomment">/// The native executable file for the target platform.</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;macos&quot;</span>, <span class="ident">target_pointer_width</span> <span class="op">=</span> <span class="string">&quot;32&quot;</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;macho&quot;</span>))]</span>
<span class="kw">pub</span> <span class="kw">type</span> <span class="ident">NativeFile</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">R</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>]<span class="op">&gt;</span> <span class="op">=</span> <span class="ident">macho::MachOFile32</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident"><span class="kw">crate</span>::Endianness</span>, <span class="ident">R</span><span class="op">&gt;</span>;

<span class="doccomment">/// The native executable file for the target platform.</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;macos&quot;</span>, <span class="ident">target_pointer_width</span> <span class="op">=</span> <span class="string">&quot;64&quot;</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;macho&quot;</span>))]</span>
<span class="kw">pub</span> <span class="kw">type</span> <span class="ident">NativeFile</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">R</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>]<span class="op">&gt;</span> <span class="op">=</span> <span class="ident">macho::MachOFile64</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident"><span class="kw">crate</span>::Endianness</span>, <span class="ident">R</span><span class="op">&gt;</span>;

<span class="doccomment">/// The native executable file for the target platform.</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;windows&quot;</span>, <span class="ident">target_pointer_width</span> <span class="op">=</span> <span class="string">&quot;32&quot;</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;pe&quot;</span>))]</span>
<span class="kw">pub</span> <span class="kw">type</span> <span class="ident">NativeFile</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">R</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>]<span class="op">&gt;</span> <span class="op">=</span> <span class="ident">pe::PeFile32</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">R</span><span class="op">&gt;</span>;

<span class="doccomment">/// The native executable file for the target platform.</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;windows&quot;</span>, <span class="ident">target_pointer_width</span> <span class="op">=</span> <span class="string">&quot;64&quot;</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;pe&quot;</span>))]</span>
<span class="kw">pub</span> <span class="kw">type</span> <span class="ident">NativeFile</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">R</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>]<span class="op">&gt;</span> <span class="op">=</span> <span class="ident">pe::PeFile64</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">R</span><span class="op">&gt;</span>;

<span class="doccomment">/// The native executable file for the target platform.</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;wasm&quot;</span>, <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;wasm32&quot;</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;wasm&quot;</span>))]</span>
<span class="kw">pub</span> <span class="kw">type</span> <span class="ident">NativeFile</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">R</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>]<span class="op">&gt;</span> <span class="op">=</span> <span class="ident">wasm::WasmFile</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">R</span><span class="op">&gt;</span>;

<span class="doccomment">/// A file format kind.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="attribute">#[<span class="ident">non_exhaustive</span>]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">FileKind</span> {
    <span class="doccomment">/// A Unix archive.</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;archive&quot;</span>)]</span>
    <span class="ident">Archive</span>,
    <span class="doccomment">/// A COFF object file.</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;coff&quot;</span>)]</span>
    <span class="ident">Coff</span>,
    <span class="doccomment">/// A dyld cache file containing Mach-O images.</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;macho&quot;</span>)]</span>
    <span class="ident">DyldCache</span>,
    <span class="doccomment">/// A 32-bit ELF file.</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;elf&quot;</span>)]</span>
    <span class="ident">Elf32</span>,
    <span class="doccomment">/// A 64-bit ELF file.</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;elf&quot;</span>)]</span>
    <span class="ident">Elf64</span>,
    <span class="doccomment">/// A 32-bit Mach-O file.</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;macho&quot;</span>)]</span>
    <span class="ident">MachO32</span>,
    <span class="doccomment">/// A 64-bit Mach-O file.</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;macho&quot;</span>)]</span>
    <span class="ident">MachO64</span>,
    <span class="doccomment">/// A 32-bit Mach-O fat binary.</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;macho&quot;</span>)]</span>
    <span class="ident">MachOFat32</span>,
    <span class="doccomment">/// A 64-bit Mach-O fat binary.</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;macho&quot;</span>)]</span>
    <span class="ident">MachOFat64</span>,
    <span class="doccomment">/// A 32-bit PE file.</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;pe&quot;</span>)]</span>
    <span class="ident">Pe32</span>,
    <span class="doccomment">/// A 64-bit PE file.</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;pe&quot;</span>)]</span>
    <span class="ident">Pe64</span>,
    <span class="doccomment">/// A Wasm file.</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;wasm&quot;</span>)]</span>
    <span class="ident">Wasm</span>,
}

<span class="kw">impl</span> <span class="ident">FileKind</span> {
    <span class="doccomment">/// Determine a file kind by parsing the start of the file.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">parse</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">R</span>: <span class="ident">ReadRef</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span>(<span class="ident">data</span>: <span class="ident">R</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">FileKind</span><span class="op">&gt;</span> {
        <span class="ident"><span class="self">Self</span>::parse_at</span>(<span class="ident">data</span>, <span class="number">0</span>)
    }

    <span class="doccomment">/// Determine a file kind by parsing at the given offset.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">parse_at</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">R</span>: <span class="ident">ReadRef</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span>(<span class="ident">data</span>: <span class="ident">R</span>, <span class="ident">offset</span>: <span class="ident">u64</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">FileKind</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">magic</span> <span class="op">=</span> <span class="ident">data</span>
            .<span class="ident">read_bytes_at</span>(<span class="ident">offset</span>, <span class="number">16</span>)
            .<span class="ident">read_error</span>(<span class="string">&quot;Could not read file magic&quot;</span>)<span class="question-mark">?</span>;
        <span class="kw">if</span> <span class="ident">magic</span>.<span class="ident">len</span>() <span class="op">&lt;</span> <span class="number">16</span> {
            <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">Error</span>(<span class="string">&quot;File too short&quot;</span>));
        }

        <span class="kw">let</span> <span class="ident">kind</span> <span class="op">=</span> <span class="kw">match</span> [<span class="ident">magic</span>[<span class="number">0</span>], <span class="ident">magic</span>[<span class="number">1</span>], <span class="ident">magic</span>[<span class="number">2</span>], <span class="ident">magic</span>[<span class="number">3</span>], <span class="ident">magic</span>[<span class="number">4</span>], <span class="ident">magic</span>[<span class="number">5</span>], <span class="ident">magic</span>[<span class="number">6</span>], <span class="ident">magic</span>[<span class="number">7</span>]] {
            <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;archive&quot;</span>)]</span>
            [<span class="string">b&#39;!&#39;</span>, <span class="string">b&#39;&lt;&#39;</span>, <span class="string">b&#39;a&#39;</span>, <span class="string">b&#39;r&#39;</span>, <span class="string">b&#39;c&#39;</span>, <span class="string">b&#39;h&#39;</span>, <span class="string">b&#39;&gt;&#39;</span>, <span class="string">b&#39;\n&#39;</span>] =&gt; <span class="ident">FileKind::Archive</span>,
            <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;macho&quot;</span>)]</span>
            [<span class="string">b&#39;d&#39;</span>, <span class="string">b&#39;y&#39;</span>, <span class="string">b&#39;l&#39;</span>, <span class="string">b&#39;d&#39;</span>, <span class="string">b&#39;_&#39;</span>, <span class="string">b&#39;v&#39;</span>, <span class="string">b&#39;1&#39;</span>, <span class="string">b&#39; &#39;</span>] =&gt; <span class="ident">FileKind::DyldCache</span>,
            <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;elf&quot;</span>)]</span>
            [<span class="number">0x7f</span>, <span class="string">b&#39;E&#39;</span>, <span class="string">b&#39;L&#39;</span>, <span class="string">b&#39;F&#39;</span>, <span class="number">1</span>, ..] =&gt; <span class="ident">FileKind::Elf32</span>,
            <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;elf&quot;</span>)]</span>
            [<span class="number">0x7f</span>, <span class="string">b&#39;E&#39;</span>, <span class="string">b&#39;L&#39;</span>, <span class="string">b&#39;F&#39;</span>, <span class="number">2</span>, ..] =&gt; <span class="ident">FileKind::Elf64</span>,
            <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;macho&quot;</span>)]</span>
            [<span class="number">0xfe</span>, <span class="number">0xed</span>, <span class="number">0xfa</span>, <span class="number">0xce</span>, ..]
            <span class="op">|</span> [<span class="number">0xce</span>, <span class="number">0xfa</span>, <span class="number">0xed</span>, <span class="number">0xfe</span>, ..] =&gt; <span class="ident">FileKind::MachO32</span>,
            <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;macho&quot;</span>)]</span>
            <span class="op">|</span> [<span class="number">0xfe</span>, <span class="number">0xed</span>, <span class="number">0xfa</span>, <span class="number">0xcf</span>, ..]
            <span class="op">|</span> [<span class="number">0xcf</span>, <span class="number">0xfa</span>, <span class="number">0xed</span>, <span class="number">0xfe</span>, ..] =&gt; <span class="ident">FileKind::MachO64</span>,
            <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;macho&quot;</span>)]</span>
            [<span class="number">0xca</span>, <span class="number">0xfe</span>, <span class="number">0xba</span>, <span class="number">0xbe</span>, ..] =&gt; <span class="ident">FileKind::MachOFat32</span>,
            <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;macho&quot;</span>)]</span>
            [<span class="number">0xca</span>, <span class="number">0xfe</span>, <span class="number">0xba</span>, <span class="number">0xbf</span>, ..] =&gt; <span class="ident">FileKind::MachOFat64</span>,
            <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;wasm&quot;</span>)]</span>
            [<span class="number">0x00</span>, <span class="string">b&#39;a&#39;</span>, <span class="string">b&#39;s&#39;</span>, <span class="string">b&#39;m&#39;</span>, ..] =&gt; <span class="ident">FileKind::Wasm</span>,
            <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;pe&quot;</span>)]</span>
            [<span class="string">b&#39;M&#39;</span>, <span class="string">b&#39;Z&#39;</span>, ..] =&gt; {
                <span class="kw">match</span> <span class="ident">pe::optional_header_magic</span>(<span class="ident">data</span>) {
                    <span class="prelude-val">Ok</span>(<span class="ident"><span class="kw">crate</span>::pe::IMAGE_NT_OPTIONAL_HDR32_MAGIC</span>) =&gt; {
                        <span class="ident">FileKind::Pe32</span>
                    }
                    <span class="prelude-val">Ok</span>(<span class="ident"><span class="kw">crate</span>::pe::IMAGE_NT_OPTIONAL_HDR64_MAGIC</span>) =&gt; {
                        <span class="ident">FileKind::Pe64</span>
                    }
                    <span class="kw">_</span> =&gt; <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">Error</span>(<span class="string">&quot;Unknown MS-DOS file&quot;</span>)),
                }
            }
            <span class="comment">// TODO: more COFF machines</span>
            <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;coff&quot;</span>)]</span>
            <span class="comment">// COFF arm</span>
            [<span class="number">0xc4</span>, <span class="number">0x01</span>, ..]
            <span class="comment">// COFF arm64</span>
            <span class="op">|</span> [<span class="number">0x64</span>, <span class="number">0xaa</span>, ..]
            <span class="comment">// COFF x86</span>
            <span class="op">|</span> [<span class="number">0x4c</span>, <span class="number">0x01</span>, ..]
            <span class="comment">// COFF x86-64</span>
            <span class="op">|</span> [<span class="number">0x64</span>, <span class="number">0x86</span>, ..] =&gt; <span class="ident">FileKind::Coff</span>,
            <span class="kw">_</span> =&gt; <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">Error</span>(<span class="string">&quot;Unknown file magic&quot;</span>)),
        };
        <span class="prelude-val">Ok</span>(<span class="ident">kind</span>)
    }
}

<span class="doccomment">/// An object kind.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="attribute">#[<span class="ident">non_exhaustive</span>]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">ObjectKind</span> {
    <span class="doccomment">/// The object kind is unknown.</span>
    <span class="ident">Unknown</span>,
    <span class="doccomment">/// Relocatable object.</span>
    <span class="ident">Relocatable</span>,
    <span class="doccomment">/// Executable.</span>
    <span class="ident">Executable</span>,
    <span class="doccomment">/// Dynamic shared object.</span>
    <span class="ident">Dynamic</span>,
    <span class="doccomment">/// Core.</span>
    <span class="ident">Core</span>,
}

<span class="doccomment">/// The index used to identify a section of a file.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">SectionIndex</span>(<span class="kw">pub</span> <span class="ident">usize</span>);

<span class="doccomment">/// The index used to identify a symbol of a file.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">SymbolIndex</span>(<span class="kw">pub</span> <span class="ident">usize</span>);

<span class="doccomment">/// The section where a symbol is defined.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="attribute">#[<span class="ident">non_exhaustive</span>]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">SymbolSection</span> {
    <span class="doccomment">/// The section is unknown.</span>
    <span class="ident">Unknown</span>,
    <span class="doccomment">/// The section is not applicable for this symbol (such as file symbols).</span>
    <span class="prelude-val">None</span>,
    <span class="doccomment">/// The symbol is undefined.</span>
    <span class="ident">Undefined</span>,
    <span class="doccomment">/// The symbol has an absolute value.</span>
    <span class="ident">Absolute</span>,
    <span class="doccomment">/// The symbol is a zero-initialized symbol that will be combined with duplicate definitions.</span>
    <span class="ident">Common</span>,
    <span class="doccomment">/// The symbol is defined in the given section.</span>
    <span class="ident">Section</span>(<span class="ident">SectionIndex</span>),
}

<span class="kw">impl</span> <span class="ident">SymbolSection</span> {
    <span class="doccomment">/// Returns the section index for the section where the symbol is defined.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// May return `None` if the symbol is not defined in a section.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">index</span>(<span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">SectionIndex</span><span class="op">&gt;</span> {
        <span class="kw">if</span> <span class="kw">let</span> <span class="ident">SymbolSection::Section</span>(<span class="ident">index</span>) <span class="op">=</span> <span class="self">self</span> {
            <span class="prelude-val">Some</span>(<span class="ident">index</span>)
        } <span class="kw">else</span> {
            <span class="prelude-val">None</span>
        }
    }
}

<span class="doccomment">/// An entry in a `SymbolMap`.</span>
<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">SymbolMapEntry</span> {
    <span class="doccomment">/// The symbol address.</span>
    <span class="kw">fn</span> <span class="ident">address</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span>;
}

<span class="doccomment">/// A map from addresses to symbols.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Default</span>, <span class="ident">Clone</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">SymbolMap</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">SymbolMapEntry</span><span class="op">&gt;</span> {
    <span class="ident">symbols</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">SymbolMapEntry</span><span class="op">&gt;</span> <span class="ident">SymbolMap</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Construct a new symbol map.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This function will sort the symbols by address.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>(<span class="kw-2">mut</span> <span class="ident">symbols</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>) -&gt; <span class="self">Self</span> {
        <span class="ident">symbols</span>.<span class="ident">sort_unstable_by_key</span>(<span class="op">|</span><span class="ident">s</span><span class="op">|</span> <span class="ident">s</span>.<span class="ident">address</span>());
        <span class="ident">SymbolMap</span> { <span class="ident">symbols</span> }
    }

    <span class="doccomment">/// Get the symbol before the given address.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">get</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">address</span>: <span class="ident">u64</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="ident">T</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">index</span> <span class="op">=</span> <span class="kw">match</span> <span class="self">self</span>
            .<span class="ident">symbols</span>
            .<span class="ident">binary_search_by_key</span>(<span class="kw-2">&amp;</span><span class="ident">address</span>, <span class="op">|</span><span class="ident">symbol</span><span class="op">|</span> <span class="ident">symbol</span>.<span class="ident">address</span>())
        {
            <span class="prelude-val">Ok</span>(<span class="ident">index</span>) =&gt; <span class="ident">index</span>,
            <span class="prelude-val">Err</span>(<span class="ident">index</span>) =&gt; <span class="ident">index</span>.<span class="ident">checked_sub</span>(<span class="number">1</span>)<span class="question-mark">?</span>,
        };
        <span class="self">self</span>.<span class="ident">symbols</span>.<span class="ident">get</span>(<span class="ident">index</span>)
    }

    <span class="doccomment">/// Get all symbols in the map.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">symbols</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span>[<span class="ident">T</span>] {
        <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">symbols</span>
    }
}

<span class="doccomment">/// A `SymbolMap` entry for symbol names.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">SymbolMapName</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> {
    <span class="ident">address</span>: <span class="ident">u64</span>,
    <span class="ident">name</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> <span class="ident">str</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> <span class="ident">SymbolMapName</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Construct a `SymbolMapName`.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>(<span class="ident">address</span>: <span class="ident">u64</span>, <span class="ident">name</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> <span class="ident">str</span>) -&gt; <span class="self">Self</span> {
        <span class="ident">SymbolMapName</span> { <span class="ident">address</span>, <span class="ident">name</span> }
    }

    <span class="doccomment">/// The symbol address.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">address</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span> {
        <span class="self">self</span>.<span class="ident">address</span>
    }

    <span class="doccomment">/// The symbol name.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">name</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> <span class="ident">str</span> {
        <span class="self">self</span>.<span class="ident">name</span>
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> <span class="ident">SymbolMapEntry</span> <span class="kw">for</span> <span class="ident">SymbolMapName</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">address</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span> {
        <span class="self">self</span>.<span class="ident">address</span>
    }
}

<span class="doccomment">/// A map from addresses to symbol names and object files.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This is derived from STAB entries in Mach-O files.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Default</span>, <span class="ident">Clone</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">ObjectMap</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> {
    <span class="ident">symbols</span>: <span class="ident">SymbolMap</span><span class="op">&lt;</span><span class="ident">ObjectMapEntry</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span>,
    <span class="ident">objects</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>]<span class="op">&gt;</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> <span class="ident">ObjectMap</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Get the entry containing the given address.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">get</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">address</span>: <span class="ident">u64</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="ident">ObjectMapEntry</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">symbols</span>
            .<span class="ident">get</span>(<span class="ident">address</span>)
            .<span class="ident">filter</span>(<span class="op">|</span><span class="ident">entry</span><span class="op">|</span> <span class="ident">entry</span>.<span class="ident">size</span> <span class="op">==</span> <span class="number">0</span> <span class="op">|</span><span class="op">|</span> <span class="ident">address</span>.<span class="ident">wrapping_sub</span>(<span class="ident">entry</span>.<span class="ident">address</span>) <span class="op">&lt;</span> <span class="ident">entry</span>.<span class="ident">size</span>)
    }

    <span class="doccomment">/// Get all symbols in the map.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">symbols</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span>[<span class="ident">ObjectMapEntry</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>] {
        <span class="self">self</span>.<span class="ident">symbols</span>.<span class="ident">symbols</span>()
    }

    <span class="doccomment">/// Get all objects in the map.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">objects</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span>[<span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>]] {
        <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">objects</span>
    }
}

<span class="doccomment">/// A `ObjectMap` entry.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Default</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">ObjectMapEntry</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> {
    <span class="ident">address</span>: <span class="ident">u64</span>,
    <span class="ident">size</span>: <span class="ident">u64</span>,
    <span class="ident">name</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>],
    <span class="ident">object</span>: <span class="ident">usize</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> <span class="ident">ObjectMapEntry</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Get the symbol address.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">address</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span> {
        <span class="self">self</span>.<span class="ident">address</span>
    }

    <span class="doccomment">/// Get the symbol size.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This may be 0 if the size is unknown.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">size</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span> {
        <span class="self">self</span>.<span class="ident">size</span>
    }

    <span class="doccomment">/// Get the symbol name.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">name</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>] {
        <span class="self">self</span>.<span class="ident">name</span>
    }

    <span class="doccomment">/// Get the index of the object file name.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">object_index</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">usize</span> {
        <span class="self">self</span>.<span class="ident">object</span>
    }

    <span class="doccomment">/// Get the object file name.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">object</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">map</span>: <span class="kw-2">&amp;</span><span class="ident">ObjectMap</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>) -&gt; <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>] {
        <span class="ident">map</span>.<span class="ident">objects</span>[<span class="self">self</span>.<span class="ident">object</span>]
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> <span class="ident">SymbolMapEntry</span> <span class="kw">for</span> <span class="ident">ObjectMapEntry</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">address</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span> {
        <span class="self">self</span>.<span class="ident">address</span>
    }
}

<span class="doccomment">/// An imported symbol.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Import</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> {
    <span class="ident">library</span>: <span class="ident">ByteString</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>,
    <span class="comment">// TODO: or ordinal</span>
    <span class="ident">name</span>: <span class="ident">ByteString</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> <span class="ident">Import</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> {
    <span class="doccomment">/// The symbol name.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">name</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>] {
        <span class="self">self</span>.<span class="ident">name</span>.<span class="number">0</span>
    }

    <span class="doccomment">/// The name of the library to import the symbol from.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">library</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>] {
        <span class="self">self</span>.<span class="ident">library</span>.<span class="number">0</span>
    }
}

<span class="doccomment">/// An exported symbol.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Export</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> {
    <span class="comment">// TODO: and ordinal?</span>
    <span class="ident">name</span>: <span class="ident">ByteString</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>,
    <span class="ident">address</span>: <span class="ident">u64</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> <span class="ident">Export</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> {
    <span class="doccomment">/// The symbol name.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">name</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>] {
        <span class="self">self</span>.<span class="ident">name</span>.<span class="number">0</span>
    }

    <span class="doccomment">/// The virtual address of the symbol.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">address</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u64</span> {
        <span class="self">self</span>.<span class="ident">address</span>
    }
}

<span class="doccomment">/// PDB Information</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">CodeView</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> {
    <span class="ident">guid</span>: [<span class="ident">u8</span>; <span class="number">16</span>],
    <span class="ident">path</span>: <span class="ident">ByteString</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span>,
    <span class="ident">age</span>: <span class="ident">u32</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> <span class="ident">CodeView</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> {
    <span class="doccomment">/// The path to the PDB as stored in CodeView</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">path</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>] {
        <span class="self">self</span>.<span class="ident">path</span>.<span class="number">0</span>
    }

    <span class="doccomment">/// The age of the PDB</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">age</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u32</span> {
        <span class="self">self</span>.<span class="ident">age</span>
    }

    <span class="doccomment">/// The GUID of the PDB.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">guid</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; [<span class="ident">u8</span>; <span class="number">16</span>] {
        <span class="self">self</span>.<span class="ident">guid</span>
    }
}

<span class="doccomment">/// The target referenced by a relocation.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="attribute">#[<span class="ident">non_exhaustive</span>]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">RelocationTarget</span> {
    <span class="doccomment">/// The target is a symbol.</span>
    <span class="ident">Symbol</span>(<span class="ident">SymbolIndex</span>),
    <span class="doccomment">/// The target is a section.</span>
    <span class="ident">Section</span>(<span class="ident">SectionIndex</span>),
    <span class="doccomment">/// The offset is an absolute address.</span>
    <span class="ident">Absolute</span>,
}

<span class="doccomment">/// A relocation entry.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Relocation</span> {
    <span class="ident">kind</span>: <span class="ident">RelocationKind</span>,
    <span class="ident">encoding</span>: <span class="ident">RelocationEncoding</span>,
    <span class="ident">size</span>: <span class="ident">u8</span>,
    <span class="ident">target</span>: <span class="ident">RelocationTarget</span>,
    <span class="ident">addend</span>: <span class="ident">i64</span>,
    <span class="ident">implicit_addend</span>: <span class="ident">bool</span>,
}

<span class="kw">impl</span> <span class="ident">Relocation</span> {
    <span class="doccomment">/// The operation used to calculate the result of the relocation.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">kind</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">RelocationKind</span> {
        <span class="self">self</span>.<span class="ident">kind</span>
    }

    <span class="doccomment">/// Information about how the result of the relocation operation is encoded in the place.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">encoding</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">RelocationEncoding</span> {
        <span class="self">self</span>.<span class="ident">encoding</span>
    }

    <span class="doccomment">/// The size in bits of the place of the relocation.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// If 0, then the size is determined by the relocation kind.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">size</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u8</span> {
        <span class="self">self</span>.<span class="ident">size</span>
    }

    <span class="doccomment">/// The target of the relocation.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">target</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">RelocationTarget</span> {
        <span class="self">self</span>.<span class="ident">target</span>
    }

    <span class="doccomment">/// The addend to use in the relocation calculation.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">addend</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">i64</span> {
        <span class="self">self</span>.<span class="ident">addend</span>
    }

    <span class="doccomment">/// Set the addend to use in the relocation calculation.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">set_addend</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">addend</span>: <span class="ident">i64</span>) {
        <span class="self">self</span>.<span class="ident">addend</span> <span class="op">=</span> <span class="ident">addend</span>
    }

    <span class="doccomment">/// Returns true if there is an implicit addend stored in the data at the offset</span>
    <span class="doccomment">/// to be relocated.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">has_implicit_addend</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">bool</span> {
        <span class="self">self</span>.<span class="ident">implicit_addend</span>
    }
}

<span class="doccomment">/// A data compression format.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="attribute">#[<span class="ident">non_exhaustive</span>]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">CompressionFormat</span> {
    <span class="doccomment">/// The data is uncompressed.</span>
    <span class="prelude-val">None</span>,
    <span class="doccomment">/// The data is compressed, but the compression format is unknown.</span>
    <span class="ident">Unknown</span>,
    <span class="doccomment">/// ZLIB/DEFLATE.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Used for ELF compression and GNU compressed debug information.</span>
    <span class="ident">Zlib</span>,
}

<span class="doccomment">/// A range in a file that may be compressed.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">CompressedFileRange</span> {
    <span class="doccomment">/// The data compression format.</span>
    <span class="kw">pub</span> <span class="ident">format</span>: <span class="ident">CompressionFormat</span>,
    <span class="doccomment">/// The file offset of the compressed data.</span>
    <span class="kw">pub</span> <span class="ident">offset</span>: <span class="ident">u64</span>,
    <span class="doccomment">/// The compressed data size.</span>
    <span class="kw">pub</span> <span class="ident">compressed_size</span>: <span class="ident">u64</span>,
    <span class="doccomment">/// The uncompressed data size.</span>
    <span class="kw">pub</span> <span class="ident">uncompressed_size</span>: <span class="ident">u64</span>,
}

<span class="kw">impl</span> <span class="ident">CompressedFileRange</span> {
    <span class="doccomment">/// Data that is uncompressed.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">none</span>(<span class="ident">range</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span>(<span class="ident">u64</span>, <span class="ident">u64</span>)<span class="op">&gt;</span>) -&gt; <span class="self">Self</span> {
        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>((<span class="ident">offset</span>, <span class="ident">size</span>)) <span class="op">=</span> <span class="ident">range</span> {
            <span class="ident">CompressedFileRange</span> {
                <span class="ident">format</span>: <span class="ident">CompressionFormat::None</span>,
                <span class="ident">offset</span>,
                <span class="ident">compressed_size</span>: <span class="ident">size</span>,
                <span class="ident">uncompressed_size</span>: <span class="ident">size</span>,
            }
        } <span class="kw">else</span> {
            <span class="ident">CompressedFileRange</span> {
                <span class="ident">format</span>: <span class="ident">CompressionFormat::None</span>,
                <span class="ident">offset</span>: <span class="number">0</span>,
                <span class="ident">compressed_size</span>: <span class="number">0</span>,
                <span class="ident">uncompressed_size</span>: <span class="number">0</span>,
            }
        }
    }

    <span class="doccomment">/// Convert to `CompressedData` by reading from the file.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">data</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, <span class="ident">R</span>: <span class="ident">ReadRef</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span>(<span class="self">self</span>, <span class="ident">file</span>: <span class="ident">R</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">CompressedData</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">data</span> <span class="op">=</span> <span class="ident">file</span>
            .<span class="ident">read_bytes_at</span>(<span class="self">self</span>.<span class="ident">offset</span>, <span class="self">self</span>.<span class="ident">compressed_size</span>)
            .<span class="ident">read_error</span>(<span class="string">&quot;Invalid compressed data size or offset&quot;</span>)<span class="question-mark">?</span>;
        <span class="prelude-val">Ok</span>(<span class="ident">CompressedData</span> {
            <span class="ident">format</span>: <span class="self">self</span>.<span class="ident">format</span>,
            <span class="ident">data</span>,
            <span class="ident">uncompressed_size</span>: <span class="self">self</span>.<span class="ident">uncompressed_size</span>,
        })
    }
}

<span class="doccomment">/// Data that may be compressed.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">CompressedData</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> {
    <span class="doccomment">/// The data compression format.</span>
    <span class="kw">pub</span> <span class="ident">format</span>: <span class="ident">CompressionFormat</span>,
    <span class="doccomment">/// The compressed data.</span>
    <span class="kw">pub</span> <span class="ident">data</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>],
    <span class="doccomment">/// The uncompressed data size.</span>
    <span class="kw">pub</span> <span class="ident">uncompressed_size</span>: <span class="ident">u64</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> <span class="ident">CompressedData</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Data that is uncompressed.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">none</span>(<span class="ident">data</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">u8</span>]) -&gt; <span class="self">Self</span> {
        <span class="ident">CompressedData</span> {
            <span class="ident">format</span>: <span class="ident">CompressionFormat::None</span>,
            <span class="ident">data</span>,
            <span class="ident">uncompressed_size</span>: <span class="ident">data</span>.<span class="ident">len</span>() <span class="kw">as</span> <span class="ident">u64</span>,
        }
    }

    <span class="doccomment">/// Return the uncompressed data.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Returns an error for invalid data or unsupported compression.</span>
    <span class="doccomment">/// This includes if the data is compressed but the `compression` feature</span>
    <span class="doccomment">/// for this crate is disabled.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">decompress</span>(<span class="self">self</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Cow</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span>, [<span class="ident">u8</span>]<span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">match</span> <span class="self">self</span>.<span class="ident">format</span> {
            <span class="ident">CompressionFormat::None</span> =&gt; <span class="prelude-val">Ok</span>(<span class="ident">Cow::Borrowed</span>(<span class="self">self</span>.<span class="ident">data</span>)),
            <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;compression&quot;</span>)]</span>
            <span class="ident">CompressionFormat::Zlib</span> =&gt; {
                <span class="kw">use</span> <span class="ident">core::convert::TryInto</span>;
                <span class="kw">let</span> <span class="ident">size</span> <span class="op">=</span> <span class="self">self</span>
                    .<span class="ident">uncompressed_size</span>
                    .<span class="ident">try_into</span>()
                    .<span class="ident">ok</span>()
                    .<span class="ident">read_error</span>(<span class="string">&quot;Uncompressed data size is too large.&quot;</span>)<span class="question-mark">?</span>;
                <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">decompressed</span> <span class="op">=</span> <span class="ident">Vec::with_capacity</span>(<span class="ident">size</span>);
                <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">decompress</span> <span class="op">=</span> <span class="ident">flate2::Decompress::new</span>(<span class="bool-val">true</span>);
                <span class="ident">decompress</span>
                    .<span class="ident">decompress_vec</span>(
                        <span class="self">self</span>.<span class="ident">data</span>,
                        <span class="kw-2">&amp;mut</span> <span class="ident">decompressed</span>,
                        <span class="ident">flate2::FlushDecompress::Finish</span>,
                    )
                    .<span class="ident">ok</span>()
                    .<span class="ident">read_error</span>(<span class="string">&quot;Invalid zlib compressed data&quot;</span>)<span class="question-mark">?</span>;
                <span class="prelude-val">Ok</span>(<span class="ident">Cow::Owned</span>(<span class="ident">decompressed</span>))
            }
            <span class="kw">_</span> =&gt; <span class="prelude-val">Err</span>(<span class="ident">Error</span>(<span class="string">&quot;Unsupported compressed data.&quot;</span>)),
        }
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="object" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>